searchData={"items":[{"type":"task","title":"mix twitch.auth","doc":"A task for getting an OAuth access token from Twitch, using the authorization\ncode flow.\n\nNOTE: To use this, you need to add the local listener to your app's redirect urls:\n\n    http://localhost:42069/oauth/callback\n\nWhere `42069` is the default `--listen-port` value. Change the port to match any\nvalue you use for this if you specify it yourself.","ref":"Mix.Tasks.Twitch.Auth.html"},{"type":"task","title":"Usage - mix twitch.auth","doc":"mix twitch.auth [OPTION]","ref":"Mix.Tasks.Twitch.Auth.html#module-usage"},{"type":"task","title":"Options - mix twitch.auth","doc":"* `--output` - Specify how we want to output the token.\n   Valid values are: `json`, `priv`, `.env`, `.envrc`, `stdout`, `clipboard`.\n   NOTE: Only `priv`, `json`, and `stdout` are supported currently.\n * `--listen-port` - The port that the temporary web server will listen on.\n   Defaults to `42069` if not set.\n * `--listen-timeout` - The time in ms that the server waits for a the twitch\n   redirect with the authorization code. Defaults to `300_000` if not set.","ref":"Mix.Tasks.Twitch.Auth.html#module-options"},{"type":"task","title":"Auth Options - mix twitch.auth","doc":"* `--client-id` - The Twitch client ID for your app. Defaults to the value\n   of the `TWITCH_CLIENT_ID` env var if not set.\n * `--client-secret` - The Twitch client secret for your app. Defaults to the\n   value of the `TWITCH_CLIENT_SECRET` env var if not set.\n * `--auth-scope` - The Twitch auth scope for your app. A space-separated\n   string. Defaults to the value of the `TWITCH_AUTH_SCOPE` env var if not set.\n   If the env var is not set, it defaults to the `default_scope` list, which\n   should be all `read` scopes except for `whisper` and `stream_key`.","ref":"Mix.Tasks.Twitch.Auth.html#module-auth-options"},{"type":"task","title":"ENV Vars - mix twitch.auth","doc":"* `TWITCH_CLIENT_ID` - The Twitch client ID for your app.\n * `TWITCH_CLIENT_SECRET` - The Twitch client secret for your app.\n * `TWITCH_AUTH_SCOPE` - The Twitch scopes as a space-separated string.","ref":"Mix.Tasks.Twitch.Auth.html#module-env-vars"},{"type":"task","title":"mix twitch.revoke","doc":"Revoke an auth token from a file or environment variable.","ref":"Mix.Tasks.Twitch.Revoke.html"},{"type":"task","title":"Usage - mix twitch.revoke","doc":"mix twitch.revoke [TOKEN] [OPTION]","ref":"Mix.Tasks.Twitch.Revoke.html#module-usage"},{"type":"task","title":"Options - mix twitch.revoke","doc":"* `--env` The name of the environment variable with the token to revoke.\n   Defaults to `TWITCH_ACCESS_TOKEN`.\n * `--json` The name of the JSON file that has the auth token to revoke.\n   Defaults to `.twitch.json`.\n * `--client_id` - The Client ID of app the token is for.\n   Defaults to fetching the value of `TWITCH_CLIENT_ID` environment variable.","ref":"Mix.Tasks.Twitch.Revoke.html#module-options"},{"type":"module","title":"TwitchAPI","doc":"Twitch API.\n\nYou can make requests to Twitch API endpoints.","ref":"TwitchAPI.html"},{"type":"module","title":"Examples - TwitchAPI","doc":"client_id = \"asdsdksdl93roi39\"\n    access_token = \"09wriujr329jd023920dk203kd0932d\"\n\n    auth = TwitchAPI.Auth.new(client_id, access_token)\n\n    case TwitchAPI.get(auth, \"/users\") do\n      {:ok, %{body: users}} ->\n        IO.inspect(users, label: \"Successful response body\")\n\n      {:error, resp} ->\n        IO.inspect(resp, label: \"We got an error\")\n    end","ref":"TwitchAPI.html#module-examples"},{"type":"function","title":"TwitchAPI.client/1","doc":"Build a base `t:Req.Request.t/0` for Twitch API requests.\n\nYou can pass either this or a `t:TwitchAPI.Auth.t/0` struct to the\nrequest functions.\n\nNOTE: You probably only want to use this directly if you want to do something\ndifferent than the default.","ref":"TwitchAPI.html#client/1"},{"type":"function","title":"TwitchAPI.delete/3","doc":"Make a Twitch API DELETE request.\nReturns `:ok` or `:error` tuples.","ref":"TwitchAPI.html#delete/3"},{"type":"function","title":"TwitchAPI.delete!/3","doc":"Make a Twitch API DELETE request.\nRaises on error or unexpected HTTP status.","ref":"TwitchAPI.html#delete!/3"},{"type":"function","title":"TwitchAPI.get/3","doc":"Make a Twitch API GET request.\nReturns `:ok` or `:error` tuples.","ref":"TwitchAPI.html#get/3"},{"type":"function","title":"TwitchAPI.get!/3","doc":"Make a Twitch API GET request.\nRaises on error or unexpected HTTP status.","ref":"TwitchAPI.html#get!/3"},{"type":"function","title":"TwitchAPI.head/3","doc":"Make a Twitch API HEAD request.\nReturns `:ok` or `:error` tuples.","ref":"TwitchAPI.html#head/3"},{"type":"function","title":"TwitchAPI.head!/3","doc":"Make a Twitch API HEAD request.\nRaises on error or unexpected HTTP status.","ref":"TwitchAPI.html#head!/3"},{"type":"function","title":"TwitchAPI.patch/3","doc":"Make a Twitch API PATCH request.\nReturns `:ok` or `:error` tuples.","ref":"TwitchAPI.html#patch/3"},{"type":"function","title":"TwitchAPI.patch!/3","doc":"Make a Twitch API PATCH request.\nRaises on error or unexpected HTTP status.","ref":"TwitchAPI.html#patch!/3"},{"type":"function","title":"TwitchAPI.post/3","doc":"Make a Twitch API POST request.\nReturns `:ok` or `:error` tuples.","ref":"TwitchAPI.html#post/3"},{"type":"function","title":"TwitchAPI.post!/3","doc":"Make a Twitch API POST request.\nRaises on error or unexpected HTTP status.","ref":"TwitchAPI.html#post!/3"},{"type":"function","title":"TwitchAPI.put/3","doc":"Make a Twitch API PUT request.\nReturns `:ok` or `:error` tuples.","ref":"TwitchAPI.html#put/3"},{"type":"function","title":"TwitchAPI.put!/3","doc":"Make a Twitch API PUT request.\nRaises on error or unexpected HTTP status.","ref":"TwitchAPI.html#put!/3"},{"type":"function","title":"TwitchAPI.stream!/4","doc":"GET pages from Twitch API as a `Stream`.\n\nYou can start at a cursor if you pass in `:cursor` as one of the `opts`.","ref":"TwitchAPI.html#stream!/4"},{"type":"type","title":"TwitchAPI.auth/0","doc":"","ref":"TwitchAPI.html#t:auth/0"},{"type":"module","title":"TwitchAPI.Auth","doc":"Twitch API Auth (and struct).\n\nFunctions for managing your auth and tokens.\n\nSee: https://dev.twitch.tv/docs/authentication/getting-tokens-oauth","ref":"TwitchAPI.Auth.html"},{"type":"module","title":"Notes - TwitchAPI.Auth","doc":"* `Implicit` grant flow gives user access tokens. Expiry: I don't know yet.\n\n * `Client Credentials` grant flow gives app access tokens that expire\n   in `5011271` seconds (~58 days).\n\n * `Authorization Code` grant flow gives user access tokens that expires\n   in `14124` seconds (~4 hours).\n\n * `Device Code` grant flow gives a user access token that expires in\n   `14820` seconds (~4 hours).","ref":"TwitchAPI.Auth.html#module-notes"},{"type":"function","title":"TwitchAPI.Auth.merge_string_params/2","doc":"Merge string params into `Auth` struct.","ref":"TwitchAPI.Auth.html#merge_string_params/2"},{"type":"function","title":"Example - TwitchAPI.Auth.merge_string_params/2","doc":"iex> auth = Auth.new(\"some-client-id\")\n    iex> params = %{\"access_token\" => \"abc123\", \"refresh_token\" => \"def456\"}\n    iex> Auth.merge_string_params(auth, params)\n    %Auth{\n      client_id: \"some-client-id\",\n      access_token: \"abc123\",\n      refresh_token: \"def456\"\n    }","ref":"TwitchAPI.Auth.html#merge_string_params/2-example"},{"type":"function","title":"TwitchAPI.Auth.new/1","doc":"Make a new `Auth` struct with a `client_id`.","ref":"TwitchAPI.Auth.html#new/1"},{"type":"function","title":"Example - TwitchAPI.Auth.new/1","doc":"iex> Auth.new(\"some-client-id\")\n    %Auth{client_id: \"some-client-id\"}","ref":"TwitchAPI.Auth.html#new/1-example"},{"type":"function","title":"TwitchAPI.Auth.new/2","doc":"Make a new `Auth` struct with a `client_id` and `client_secret`.","ref":"TwitchAPI.Auth.html#new/2"},{"type":"function","title":"Example - TwitchAPI.Auth.new/2","doc":"iex> Auth.new(\"some-client-id\", \"secretssss\")\n    %Auth{client_id: \"some-client-id\", client_secret: \"secretssss\"}","ref":"TwitchAPI.Auth.html#new/2-example"},{"type":"function","title":"TwitchAPI.Auth.new/3","doc":"Make a new `Auth` struct with a `client_id`, `client_secret`, and `access_token`.","ref":"TwitchAPI.Auth.html#new/3"},{"type":"function","title":"Example - TwitchAPI.Auth.new/3","doc":"iex> Auth.new(\"some-client-id\", \"secretssss\", \"sometokenabc123\")\n    %Auth{client_id: \"some-client-id\", client_secret: \"secretssss\", access_token: \"sometokenabc123\"}","ref":"TwitchAPI.Auth.html#new/3-example"},{"type":"function","title":"TwitchAPI.Auth.new/4","doc":"Make a new `Auth` struct with a `client_id`, `client_secret`, `access_token`, and `refresh_token`.","ref":"TwitchAPI.Auth.html#new/4"},{"type":"function","title":"Example - TwitchAPI.Auth.new/4","doc":"iex> Auth.new(\"some-client-id\", \"secretssss\", \"sometokenabc123\", \"somerefreshabc123\")\n    %Auth{\n      client_id: \"some-client-id\",\n      client_secret: \"secretssss\",\n      access_token: \"sometokenabc123\",\n      refresh_token: \"somerefreshabc123\"\n    }","ref":"TwitchAPI.Auth.html#new/4-example"},{"type":"function","title":"TwitchAPI.Auth.put_access_token/2","doc":"Add an `access_token` to the `Auth` struct.","ref":"TwitchAPI.Auth.html#put_access_token/2"},{"type":"function","title":"Example - TwitchAPI.Auth.put_access_token/2","doc":"iex> auth = Auth.new(\"some-client-id\")\n    iex> Auth.put_access_token(auth, \"abc123\")\n    %Auth{client_id: \"some-client-id\", access_token: \"abc123\"}","ref":"TwitchAPI.Auth.html#put_access_token/2-example"},{"type":"function","title":"TwitchAPI.Auth.put_client_secret/2","doc":"Add a `client_secret` to the `Auth` struct.","ref":"TwitchAPI.Auth.html#put_client_secret/2"},{"type":"function","title":"Example - TwitchAPI.Auth.put_client_secret/2","doc":"iex> auth = Auth.new(\"some-client-id\")\n    iex> Auth.put_client_secret(auth, \"secretssss\")\n    %Auth{client_id: \"some-client-id\", client_secret: \"secretssss\"}","ref":"TwitchAPI.Auth.html#put_client_secret/2-example"},{"type":"type","title":"TwitchAPI.Auth.t/0","doc":"","ref":"TwitchAPI.Auth.html#t:t/0"},{"type":"behaviour","title":"TwitchAPI.AuthCallbacks","doc":"Behaviour defined for `TwitchAPI.AuthStore` callback options.","ref":"TwitchAPI.AuthCallbacks.html"},{"type":"callback","title":"TwitchAPI.AuthCallbacks.load/2","doc":"This function is called after the `TwitchAPI.AuthStore.init/2` function is\ncalled, and before the token is validated (and attempted to refresh if not\nvalid).","ref":"TwitchAPI.AuthCallbacks.html#c:load/2"},{"type":"callback","title":"TwitchAPI.AuthCallbacks.put/2","doc":"This function is called whenever a `t:TwitchAPI.Auth.t/0` is added to the\nstore and every time a token is refreshed.","ref":"TwitchAPI.AuthCallbacks.html#c:put/2"},{"type":"callback","title":"TwitchAPI.AuthCallbacks.terminate/2","doc":"This function is called whenever the `TwitchAPI.AuthStore.terminate/2`\nfunction is called. It is useful for any clean-up needed.","ref":"TwitchAPI.AuthCallbacks.html#c:terminate/2"},{"type":"type","title":"TwitchAPI.AuthCallbacks.name/0","doc":"The `name` argument is the name used to register the auth store in the \n`Registry`, and is useful for distinguishing between different auth stores\nif you have many.","ref":"TwitchAPI.AuthCallbacks.html#t:name/0"},{"type":"module","title":"TwitchAPI.AuthClient","doc":"Auth client for Twitch.","ref":"TwitchAPI.AuthClient.html"},{"type":"function","title":"TwitchAPI.AuthClient.token_get_from_code/3","doc":"Get an access token with an authorization code.\n\nhttps://dev.twitch.tv/docs/authentication/getting-tokens-oauth/#authorization-code-grant-flow\n\nIf the request succeeds, it returns an access token and refresh token.\n\n    {\n      \"access_token\": \"rfx2uswqe8l4g1mkagrvg5tv0ks3\",\n      \"expires_in\": 14124,\n      \"refresh_token\": \"5b93chm6hdve3mycz05zfzatkfdenfspp1h1ar2xxdalen01\",\n      \"scope\": [\n        \"channel:moderate\",\n        \"chat:edit\",\n        \"chat:read\"\n      ],\n      \"token_type\": \"bearer\"\n    }","ref":"TwitchAPI.AuthClient.html#token_get_from_code/3"},{"type":"function","title":"TwitchAPI.AuthClient.token_refresh/1","doc":"Refresh an access token.\n\nhttps://dev.twitch.tv/docs/authentication/refresh-tokens\n\nIf the request succeeds, the response contains the new access token, refresh\ntoken, and scopes associated with the new grant. Because refresh tokens may\nchange, your app should safely store the new refresh token to use the next time.\n\n    {\n      \"access_token\": \"1ssjqsqfy6bads1ws7m03gras79zfr\",\n      \"refresh_token\": \"eyJfMzUtNDU0OC4MWYwLTQ5MDY5ODY4NGNlMSJ9%asdfasdf=\",\n      \"scope\": [\n        \"channel:read:subscriptions\",\n        \"channel:manage:polls\"\n      ],\n      \"token_type\": \"bearer\"\n    }\n\nThe following example shows what the response looks like if the request fails.\n\n    {\n      \"error\": \"Bad Request\",\n      \"status\": 400,\n      \"message\": \"Invalid refresh token\"\n    }","ref":"TwitchAPI.AuthClient.html#token_refresh/1"},{"type":"function","title":"TwitchAPI.AuthClient.token_refresh_step/1","doc":"A response step (`Req.Step`) for refreshing tokens and re-attempting a request\nwhen authentication fails.\n\nIf the `Auth` struct has a `client_secret` and `refresh_token` and has not\nalready been attempted, then we will attempt to refresh the token.","ref":"TwitchAPI.AuthClient.html#token_refresh_step/1"},{"type":"function","title":"Example - TwitchAPI.AuthClient.token_refresh_step/1","doc":"Req.new(url: \"https://api.twitch.com/helix/users\")\n  |> Req.Request.append_response_steps(token_refresh: &TwitchAPI.Auth.token_refresh_step/1)","ref":"TwitchAPI.AuthClient.html#token_refresh_step/1-example"},{"type":"function","title":"TwitchAPI.AuthClient.token_revoke/1","doc":"Revoke an access token.\n\nhttps://dev.twitch.tv/docs/authentication/revoke-tokens\n\nIf the revocation succeeds, the request returns HTTP status code 200 OK (with no body).\n\nIf the revocation fails, the request returns one of the following HTTP status codes:\n\n * 400 Bad Request if the client ID is valid but the access token is not.\n\n    {\n      \"status\": 400,\n      \"message\": \"Invalid token\"\n    }\n\n * 404 Not Found if the client ID is not valid.\n\n    {\n      \"status\": 404,\n      \"message\": \"client does not exist\"\n    }","ref":"TwitchAPI.AuthClient.html#token_revoke/1"},{"type":"function","title":"TwitchAPI.AuthClient.token_validate/1","doc":"Validate an access token.\n\nhttps://dev.twitch.tv/docs/authentication/validate-tokens/#how-to-validate-a-token\n\nIf the token is valid, the request returns HTTP status code 200 and the\nresponse’s body contains the following JSON object:\n\n    {\n      \"client_id\": \"wbmytr93xzw8zbg0p1izqyzzc5mbiz\",\n      \"login\": \"twitchdev\",\n      \"scopes\": [\n        \"channel:read:subscriptions\"\n      ],\n      \"user_id\": \"141981764\",\n      \"expires_in\": 5520838\n    }\n\nIf the token is not valid, the request returns HTTP status code 401 and the\nresponse’s body contains the following JSON object:\n\n    {\n      \"status\": 401,\n      \"message\": \"invalid access token\"\n    }","ref":"TwitchAPI.AuthClient.html#token_validate/1"},{"type":"module","title":"TwitchAPI.AuthFile","doc":"Some functions to read and write Twitch Auth from and to a file.","ref":"TwitchAPI.AuthFile.html"},{"type":"module","title":"TwitchAPI.AuthNoop","doc":"Some functions that no-op.","ref":"TwitchAPI.AuthNoop.html"},{"type":"module","title":"TwitchAPI.AuthStore","doc":"Storage for Twitch Auth.","ref":"TwitchAPI.AuthStore.html"},{"type":"module","title":"The callback options - TwitchAPI.AuthStore","doc":"These can be useful for things like loading and saving the auth tokens to a\nmore persisten store (or file) between app restarts or deploys.\n\nThe callback options accept either a module that implements the\n`TwitchAPI.AuthCallbacks` behaviour, a function, or a tuple in the standard\nformat of `{Module, :function, [args]}` (MFA).\n\nIf you use an MFA the first two args passed to you function will still always\nbe `name` and `auth`, and the rest will be the ones you pass in `[args]`.\n\nThey default to `TwitchAPI.AuthNoop` unless you supply the `:callback_module`\noption, this will be used instead.\n\n * `:on_load` - Called after auth store init and before token is validated.\n * `:on_put` - Called when `t:TwitchAPI.Auth.t/0` is added to auth store or\n   token is refreshed.\n * `:on_terminate` - Called when the `TwitchAPI.AuthStore` terminates.","ref":"TwitchAPI.AuthStore.html#module-the-callback-options"},{"type":"function","title":"TwitchAPI.AuthStore.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"TwitchAPI.AuthStore.html#child_spec/1"},{"type":"function","title":"TwitchAPI.AuthStore.get/1","doc":"Get the auth from the auth store.","ref":"TwitchAPI.AuthStore.html#get/1"},{"type":"function","title":"TwitchAPI.AuthStore.put/2","doc":"Put the auth in the auth store.","ref":"TwitchAPI.AuthStore.html#put/2"},{"type":"function","title":"TwitchAPI.AuthStore.start_link/1","doc":"Start the auth store.","ref":"TwitchAPI.AuthStore.html#start_link/1"},{"type":"type","title":"TwitchAPI.AuthStore.auth_store_callback/0","doc":"See the `TwitchAPI.AuthStore` module docs for an explanation.","ref":"TwitchAPI.AuthStore.html#t:auth_store_callback/0"},{"type":"type","title":"TwitchAPI.AuthStore.name/0","doc":"The `name` argument is the name used to register the auth store in the\n`Registry`, and is useful for distinguishing between different auth stores\nif you have many.","ref":"TwitchAPI.AuthStore.html#t:name/0"},{"type":"type","title":"TwitchAPI.AuthStore.option/0","doc":"","ref":"TwitchAPI.AuthStore.html#t:option/0"},{"type":"opaque","title":"TwitchAPI.AuthStore.state/0","doc":"","ref":"TwitchAPI.AuthStore.html#t:state/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}